var express = require('express');
var app     = express();

var http    = require('http').Server(app);
var io      = require('socket.io')(http);
var random  = require('./random.js');

const PORT = 3000;
var getIP   = require('./getIP.js');

var getPort = () => {
	return PORT;
}

// Set unique server token for each start
var serverToken = random.string(10);


// Express Routing
app.get('/', (req, res)  => {
	res.sendFile(__dirname + '/web/index.html');
});
app.get('/serverToken', (req, res) => {
	res.json({serverToken: serverToken});
});
app.use( express.static(__dirname + '/web/assets') );

app.get('*', (req, res) => {
	res.status(404).send('Page not found'); // replace to 404 file
});

// Socket.IO
io.on('connection', (socket) => {
	socket.getID = () => {
		return '#' + socket.id.substr(0, 6);
	}

	socket.log   = (text) => {
		console.log('[' + socket.getID() + '] ' + text);
	}

	socket.log('new connection');
})


// Http listener
http.listen(PORT, () => {
	console.log('Server is listening on ' + getIP() + ':' + getPort());
});
