class Camera {
	constructor (widht, height, mapWidth, mapHeight) {
		// Actually the width and height of canvas
		this.width     = widht;
		this.height    = height;
		this.map = {
			width: mapWidth,
			height: mapHeight
		};
		this.speed = 15;

		// Center point of camera
		this.x      = null;
		this.y      = null;

		this.lastFieldIndex = 0;
	}
	draw () {
		stroke(0, 255, 0);
		strokeWeight(2);
		noFill();
		rect(0, 0, this.width, this.height);
	}
	checkDraw (object) {
		let x      = object.x;
		let y      = object.y;
		let width  = object.width;
		let height = object.height;

		return (
			(x + width >= this.x) &&
			(y + height >= this.y) &&
			(x <= this.x + this.width) &&
			(y <= this.y + this.height)
		);
	}
	move (direction) {
		if(direction == 'up') {
			this.y -= this.speed;

			if(this.y < 0)
				this.y = 0;

		}
		if(direction == 'right') {
			this.x += this.speed;

			if(this.x + this.width > this.map.width)
				this.x = this.map.width - this.width;

		}
		if(direction == 'down') {
			this.y += this.speed;

			if(this.y + this.height > this.map.height)
				this.y = this.map.height - this.height;

		}
		if(direction == 'left') {
			this.x -= this.speed;

			if(this.x < 0)
				this.x = 0;

		}

	}
	drawFields (map) {
		var firstField = {
			column: Math.floor( this.x / map.field.width ),
			row: Math.floor( this.y / map.field.height )
		}
		

		var lastField = {
			column: Math.floor( (this.x + this.width) / map.field.width ),
			row: Math.floor( (this.y + this.height) / map.field.height )
		}
		// console.log('this.x + this.width: ', (this.x + this.width));

		// console.log('firstRow: ', firstField.row, ' firstColumn: ', firstField.column, ' rows: ', lastField.row, ' columns: ', lastField.column);
		// console.log('field index: ', index);
		// console.log(firstField, lastField, (firstField.column + firstField.row * map.field.size.row));
		for(var i = firstField.column; i < lastField.column; i++)
		{
			for(var j = firstField.row; j < lastField.row; j++)
			{
				var index = i + j * map.field.size.row;
				this.lastFieldIndex = index;
				map.fields[index].draw(this.x, this.y);
			}
		}
		
	}
	drawWalls () {
		// Way to draw walls as long as they are in Camera
	}
	setPosition (x, y) {
		this.x = x;
		this.y = y;
	}
	setOnUser (player) {
		// player must be instance of class Player
		
		// this.x = player.x;
		// this.y = player.y;

		this.x = player.x - this.width/2;
		this.y = player.y - this.height/2;

		// return false;

		if(player.x < this.width/2) {
			this.x = 0;
			console.log('case 1');
		}
		if(player.x > this.map.width - this.width/2) {
			this.x = this.map.width - this.width;
			console.log('case 2');
		}

		if(player.y < this.height/2) {
			this.y = 0;
			console.log('case 3');
		}
		if(player.y > this.map.height - this.height/2) {
			this.y = this.map.height - this.height;
			console.log('case 4');
		}
	}
}