class Game {
	constructor (config) {

		this.config = config;

		// All coordinates are given in fields
		// width, height, fieldWidth, fieldHeight, fieldRowCount, fieldColumnCount
		this.map = new Map(this.config);
		// this.map = new Map(5000, 5000, 50, 50, 100, 100);
		this.map.makeFields();

		this.user = new Player(this.config);
		// this.user.setField();
		this.user.setCoordinates(500, 500); // ?
		// rand from server - position, direction
		this.user.setDirection('right');
		this.user.stoped = true;
		// this.user.setSize(50, 50); // ?

		this.camera = new Camera(600, 600, this.map.width, this.map.height);
		this.camera.setPosition(0, 0);
		// this.camera.setOnUser(this.user);

		this.players = [];
		this.started = false;
	}

	start () {
		this.started = true;
		console.log('Game is starting');
	}

	tick () {
		this.move();
		this.draw();
	}

	move () {
		this.user.move();
		this.camera.setOnUser(this.user);
	}

	draw () {
		// draw walls
		this.camera.draw();
		this.camera.drawWalls();

		this.camera.drawFields(this.map);
		
		// draw user
		if(this.camera.checkDraw(this.user)) 
			this.user.draw(this.camera.x, this.camera.y);
	}

}