class Map {
	constructor (config) {
		
		this.config = config;
		
		this.width  = 0;
		this.height = 0;
		this.fields = [];
		this.field  = {
			count:  0,
			width:  0,
			height: 0,
			size:   {
				row:    0,
				column: 0
			}
		}

		this.loadConfig();
	}

	loadConfig () {
		this.width  = this.config.map.width;
		this.height = this.config.map.height;

		this.field.width  = this.config.field.width;
		this.field.height = this.config.field.height;

		this.field.size.row = this.config.field.rowCount;
		this.field.size.column = this.config.field.columnCount;
	}

	makeFields () {
		this.fields      = [];
		this.field.count = 0;
		console.log('Making fields');

		for(var i = 0; i < this.field.size.row; i++)
		{
			for(var j = 0; j < this.field.size.column; j++)
			{

				var number = j + i * this.field.size.column;
				var x      = j * this.field.width;
				var y      = i * this.field.height;
				var width  = this.field.width;
				var height = this.field.height;

				this.fields.push(new Field(number, x, y, width, height));

				this.field.count++;

			}
		}
	}
}