class Player {
	// move setting values to setup() function?
	constructor (config) {
		this.config = config;
		this.x      = null;
		this.y      = null;
		this.width  = null;
		this.height = null;
		this.field  = null;
		this.id     = null;
		this.nick   = null;

		this.speed     = null;
		this.direction = null;
		this.stoped    = false;

		this.color  = {r: null, g: null, b: null};

		this.loadConfig();
	}

	loadConfig () {
		this.width  = this.config.player.width;
		this.height = this.config.player.height;

		this.speed  = this.config.player.speed;

		this.color  = this.config.player.color;
	}

	setField (field) {
		this.setCoordinates(field.x, field.y);
	}
	setID (id) {
		this.id = id;
	}
	setNick (nick) {
		this.nick = nick;
	}
	setDirection (direction) {
		if(direction == this.direction)
			return false;

		if(direction == 'up' && this.direction != 'down') {

			this.direction = 'up';
			return true;

		}
		if(direction == 'right' && this.direction != 'left') {

			this.direction = 'right';
			return true;

		}
		if(direction == 'down' && this.direction != 'up') {

			this.direction = 'down';
			return true;
			
		}
		if(direction == 'left' && this.direction != 'right') {

			this.direction = 'left';
			return true;
			
		}

		console.log('Bad direction')
		return false;
	}
	setCoordinates (x, y) {
		this.x = x;
		this.y = y;
	}
	setSize (width, height) {
		this.width  = width;
		this.height = height;
	}
	draw (x = 0, y = 0) {
		x = this.x - x;
		y = this.y - y;
		noStroke();
		fill(this.color.r, this.color.g, this.color.b)
		rect(x, y, this.width, this.height);

		if(this.id != null) {
			noStroke();
			fill(255, 0, 0);
			textSize(10);
			textAlign(CENTER, CENTER);
			text(this.id, x + this.width/2, y + this.height/2);
		}
	}
	canMove (direction) {

	}
	changeMoving () {
		this.stoped = !this.stoped;
	}
	move () {
		if(this.stoped)
			return false;
		if(this.direction == 'up') {

			this.y -= this.speed;
			return true;

		}

		if(this.direction == 'right') {

			this.x += this.speed;
			return true;

		}

		if(this.direction == 'down') {

			this.y += this.speed;
			return true;

		}

		if(this.direction == 'left') {

			this.x -= this.speed;
			return true;

		}

	}
}